{ VERSION: 1.0 }
{ 1.0 / 15.5.2005
  - nov kompilan pepna JET_DRIVER_xxx pepn mezi ZeosLib,
    ADO a ODBC. Nejrychlej se zd bt ODBC pstup
}
unit uMyskaBaseJetStore;

// TUNE:
// ZEOS: funguje ale pomalu a v puvodnim zeosu se musi opravit nejake chyby
{ $DEFINE JET_DRIVER_ZEOS}
// ADO: funguje ale taky celkem pomalu
{ $DEFINE JET_DRIVER_ADO}
// ODBC: funguje dobre
{$DEFINE JET_DRIVER_ODBC}

interface
uses
  uMyskaDB, uMyskaSQL, Classes, DB
  {$IFDEF JET_DRIVER_ZEOS}
  ,uMyskaZeosDB
  {$ENDIF}
  {$IFDEF JET_DRIVER_ADO}
  ,uMyskaAdoDB
  {$ENDIF}
  {$IFDEF JET_DRIVER_ODBC}
  ,uMyskaODBCDB
  {$ENDIF}
  ;

{$IFDEF JET_DRIVER_ZEOS}
type
  TMyskaBaseJetStore = class(TZeosStore)
  protected
    procedure ConfigureConnection(Params: TStrings); override;
  end;
{$ENDIF}
{$IFDEF JET_DRIVER_ADO}
type
  TMyskaBaseJetStore = class(TAdoStore)
  protected
    procedure ConfigureConnection(Params: TStrings); override;
  end;
{$ENDIF}
{$IFDEF JET_DRIVER_ODBC}
type
  TMyskaBaseJetStore = class(TODBCStore)
  protected
    procedure ConfigureConnection(Params: TStrings); override;
  end;
{$ENDIF}

implementation
uses
  {$IFDEF JET_DRIVER_ZEOS}
  ZdbcJet,
  {$ENDIF}
  {$IFDEF JET_DRIVER_ADO}
  {$ENDIF}
  SysUtils;

{$IFDEF JET_DRIVER_ZEOS}
procedure TMyskaBaseJetStore.ConfigureConnection(Params: TStrings);

  function Param(const ID: string; const DefaultValue: string = ''): string;
  begin
    Result := Params.Values[ID];
    if Result = '' then
      Result := DefaultValue
  end;

begin
  FDBase.Protocol := Param('protocol', 'jet');
  FDBase.HostName := Param('host');
  FDBase.Database := Param('db');
  FDBase.User := Param('user', 'Admin');
  FDBase.Password := Param('password', '');
end;
{$ENDIF}

{$IFDEF JET_DRIVER_ADO}
procedure TMyskaBaseJetStore.ConfigureConnection(Params: TStrings);

  function Param(const ID: string; const DefaultValue: string = ''): string;
  begin
    Result := Params.Values[ID];
    if Result = '' then
      Result := DefaultValue
  end;

begin
  FDBase.ConnectionString := Format(
    'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s;Mode=Share Deny Read|Share Deny Write;Persist Security Info=False',
    [Param('db')]);
  Params.Values['user'] := Param('user', 'Admin');
  Params.Values['password'] := Param('password', '');
end;
{$ENDIF}

{$IFDEF JET_DRIVER_ODBC}
procedure TMyskaBaseJetStore.ConfigureConnection(Params: TStrings);

  function Param(const ID: string; const DefaultValue: string = ''): string;
  begin
    Result := Params.Values[ID];
    if Result = '' then
      Result := DefaultValue
  end;

begin
  with FDBase.Params do begin
    Values['DRIVER'] := 'Microsoft Access Driver (*.mdb)';
    Values['UID'] := Param('user', 'Admin');
    // TODO:  Param('password', '');
    Values['ReadOnly'] := '0';
    Values['FIL'] := 'MS Access';
    Values['Exclusive'] := '1';
    Values['DBQ'] := Param('db')
  end;
end;
{$ENDIF}

end.
