{ VERSION: 2.4 }
{ Vizuln komponenta pro zobrazen stromu rznorodch objekt }
{ 2.4 / 1.10.2005
  - funkce LoadLayout() a SaveLayout() sebou penej njak slo
  2.3 / 20.9.2005
  - nov funkce TCustomObjectTree.GetSortedColumn() inverzn k SetSortedColumn()
  - zmna vzhledu zhlav: sloupec podle kterho je azen m jinou barvu
  - nov udlost OnGetCellColor umouje nastavit barvu pozad jednotlivch buek
  2.2 / 28.8.2005
  - nov vlastnost TCustomObjectTree.AutoSize: Boolean pro samoroztahovac sloupce
  - vlastnost TObjectTree.SelectedColumn funguje i pro zpis
  1.9 / 12.6.2005
  - nov vlastnost TObjectTree.SelectedColumn: TMappedColumn
  - nov udlost OnRefresh se spout v reakci na klvesu F5
  - sloupce kter maj v nzvu oddlova dk '\' nebo #13#10 se zobraz
    vce-dkov
  - opraveno: po pesunu Selected v dsledku vyhledn se nevyslal signl OnChange
  1.6 / 12.5.2005
  - nov udlost OnGetNodeColor umouje nastavit barvu pozad dku
  - nov vlastnost Path: string zjiuje / nastavuje stromov jmno ( jmno zahrnujc
    vechny pedky ve stromu ) vybranho uzlu. funguje vlastn jako TDataSet.Bookmark a navc
    se d zobrazit uivateli
  1.5 / 11.5.2005
  - nov soustka TTreeLayout pro uloen / obnoven rozloen sloupc stromu. Pouv
    se to pes Assign. Bu se zavol TTreeLayout.Assign(TObjectTree) nebo TObjectTree.Assign(TTreeLayout).
    TTreeLayout se d streamovat ( tj. uloit do streamu )
  1.4 / 10.5.2005
  - opraveno: dvoj klik nedlal oteven / zaven skupiny. Te to dl dvojklik
    ve sloupci se stromem
  1.3 / 9.5.2005
  - nov vlastnosti TObjectTree.FocusedNode: TTreeNode a TObjectTree.FocusedColumn: Integer
  - nov vlastnost TObjectTree.Selected: TTreeNode
  - nov udlost TObjectTree.OnChange(, Node: TTreeNode) se vysl pi zmn
    vybranho dku
  - nov funkce TObjectTree.Path(Node: TTreeNode): string vrac popis pozice ve stromu
  - klvesa CTRL+F vyvol vyhledvac dialog. Vyhledvn probh na cel obrazovce, i v kolapsovanch
    uzlech.
    klvesa F3 vyhled dal vskyt.
  - zarovnn text se provd podle vlastnosti uObjectTree.TColumnDescriptor.Alignment
  1.2 / 2.5.2005
  - zobrazen plus na zatku se automaticky pepn podle toho, jestli
    strom zobrazuje vc rovn nebo jenom jednu
  - kliknutm na zhlav sloupce se sloupec sead. pro azen vol
    pslunou adc funkci TColumnDescriptor.Compare()
  - kter sloupec je seazen jako vchoz se d nastavit metodou SetSortedColumn()
  1.1 / 26.4.2005
}
unit uObjectTreeView;

interface
uses
  Windows, Messages, Controls, Graphics, Classes, VirtualTrees, uObjectTree, Dialogs, IniFiles;

type
  PTreeData = ^TTreeData;
  TTreeData = packed record
    Data: TTreeNode;
    Key: TNodeKey;
  end;

  TCustomObjectTree = class;

  TColumnSort = (csNone, csDown, csUp);
  TColumnLayout = class(TCollectionItem)
  private
    FColumnName: string;
    FColumnPosition: Integer;
    FHeaderAlignment: TAlignment;
    FWidth: Integer;
    FVisible: Boolean;
    FSorted: TColumnSort;
  protected
    procedure AssignTo(Dest: TPersistent); override;
  public
    constructor Create(ACollection: TCollection); override;
    procedure Assign(Source: TPersistent); override;
  published
    property ColumnName: string read FColumnName write FColumnName;
    property ColumnPosition: Integer read FColumnPosition write FColumnPosition;
    property HeaderAlignment: TAlignment read FHeaderAlignment write FHeaderAlignment default Classes.taLeftJustify;
    property Width: Integer read FWidth write FWidth default 50;
    property Visible: Boolean read FVisible write FVisible default True;
    property Sorted: TColumnSort read FSorted write FSorted default csNone;
  end;
  TColumnLayouts = class(TCollection)
  private
    function GetItem(Index: Integer): TColumnLayout;
  public
    function Add: TColumnLayout;
    property Items[Index: Integer]: TColumnLayout read GetItem; default;
  end;
  TTreeLayout = class(TComponent)
  private
    FColumns: TColumnLayouts;
    FTree: TCustomObjectTree;
    procedure SetColumns(Value: TColumnLayouts);
  protected
    procedure AssignTo(Dest: TPersistent); override;
  public
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;
    procedure Clear;
    procedure Assign(Source: TPersistent); override;
  published
    property Columns: TColumnLayouts read FColumns write SetColumns;
  end;

  TTreeChangeEvent = procedure (Sender: TCustomObjectTree; Node: TTreeNode) of object;
  TTreeGetNodeColorEvent = procedure (Sender: TCustomObjectTree; Node: TTreeNode; var Color: TColor) of object;
  TTreeGetCellColorEvent = procedure (Sender: TCustomObjectTree; Node: TTreeNode; Column: TColumnDescriptor; var Color: TColor) of object;
  TCustomObjectTree = class(TCustomVirtualStringTree)
  private
    FOnRefresh: TNotifyEvent;
    FOnChange: TTreeChangeEvent;
    FOnGetNodeColor: TTreeGetNodeColorEvent;
    FOnGetCellColor: TTreeGetCellColorEvent;
    FInternalDataOffset: Cardinal;
    FHasLevels: Boolean;
    FDepth: Integer;
    FAutoSize: Boolean;
    function GetDepth: Integer;
    procedure DoChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure DoIncrementalSearch(Sender: TBaseVirtualTree; Node: PVirtualNode; const SearchText: WideString; var Result: Integer);
    procedure SetHasLevels(Value: Boolean);
    procedure AdjustColors;
  protected
    FObjects: TTree;
    property HasLevels: Boolean read FHasLevels write SetHasLevels;
    property Depth: Integer read GetDepth;
  protected
    function GetInternalData(Node: PVirtualNode): TTreeNode; overload;
    function GetInternalData(Node: PVirtualNode; ColumnIndex: Integer; var Column: TColumnDescriptor): TTreeNode; overload;
    procedure SetInternalData(Node: PVirtualNode; Data: TTreeNode);
  private
    DblClickState: Integer;
  protected
    procedure DoPaintNode(var PaintInfo: TVTPaintInfo); override;
    procedure DoGetText(Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var Text: WideString); override;
    procedure DoHeaderClick(Column: TColumnIndex; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    function DoKeyAction(var CharCode: Word; var Shift: TShiftState): Boolean; override;
    function DoCompare(Node1, Node2: PVirtualNode; Column: TColumnIndex): Integer; override;
    procedure DoBeforeCellPaint(Canvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; CellRect: TRect); override;
    procedure HandleMouseDown(var Message: TWMMouse; const HitInfo: THitInfo); override;
    procedure HandleMouseDblClick(var Message: TWMMouse; const HitInfo: THitInfo); override;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    procedure CMColorChange(var Message: TMessage); message CM_COLORCHANGED;
    procedure DblClick; override;
    procedure CMSysColorChange(var Message: TMessage); message CM_SYSCOLORCHANGE;
    procedure Loaded; override;
    procedure PrepareMultilineHeader(Sender: TVTHeader; var PaintInfo: THeaderPaintInfo; var Elements: THeaderPaintElements);
    procedure DrawMultilineHeader(Sender: TVTHeader; var PaintInfo: THeaderPaintInfo; const Elements: THeaderPaintElements);
  protected
    function  Find(const SearchText: string; MatchCase: Boolean; Down: Boolean; WholeWord: Boolean; var Node: PVirtualNode; var Column: Integer): Boolean;
    procedure FindDialogFindNext; virtual;
    function  FindDialogActive: Boolean; virtual;
  public
    procedure FindDialogOpen; virtual;
  protected
    procedure DoRefresh; virtual;
  public
    procedure AfterConstruction; override;
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetSortedColumn(Index: Integer; Descending: Boolean = False);
    function GetSortedColumn(var Column: TMappedColumn; var Descending: Boolean): Boolean;
  private
    function GetCurrentPath: string;
    procedure SetCurrentPath(const Value: string);
  protected
    function GetPath(Node: TTreeNode): string; overload;
    function GetPath(const Path: string): TTreeNode; overload;
  public
    function GetParent(Node: TTreeNode; Depth: Integer = 0): TTreeNode;
  public
    property Path: string read GetCurrentPath write SetCurrentPath;
    property Objects: TTree read FObjects;
  private
    function GetFocusedNode: TTreeNode;
    procedure SetFocusedNode(Value: TTreeNode);
    function GetSelectedNode: TTreeNode;
    procedure SetSelectedNode(Value: TTreeNode);
    function GetSelectedColumn: TMappedColumn;
    procedure SetSelectedColumn(Value: TMappedColumn);
  protected
    property FocusedNode: TTreeNode read GetFocusedNode write SetFocusedNode;
    property Selected: TTreeNode read GetSelectedNode write SetSelectedNode;
    property SelectedColumn: TMappedColumn read GetSelectedColumn write SetSelectedColumn;
    property OnChange: TTreeChangeEvent read FOnChange write FOnChange;
    property OnGetNodeColor: TTreeGetNodeColorEvent read FOnGetNodeColor write FOnGetNodeColor;
    property OnGetCellColor: TTreeGetCellColorEvent read FOnGetCellColor write FOnGetCellColor;
    property OnRefresh: TNotifyEvent read FOnRefresh write FOnRefresh;
  public
    property AutoSize: Boolean read FAutoSize write FAutoSize;
  end;

  TObjectTree = class(TCustomObjectTree)
  public
    property FocusedNode;
    property Selected;
    property FocusedColumn;
    property SelectedColumn;
  published
    property Align;
    property BorderStyle;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnDblClick;
    property OnChange;
    property OnGetNodeColor;
    property OnGetCellColor;
    property OnRefresh;
    property Colors;
    property Color;
  end;

procedure LoadLayoutsFromIni(Ini: TCustomIniFile; const Section: string);
procedure SaveLayoutsToIni(Ini: TCustomIniFile; const Section: string);

function LoadLayout(const ID: string; Tree: TCustomObjectTree): Integer;
procedure SaveLayout(const ID: string; Tree: TCustomObjectTree; Tag: Integer = 0);

procedure Register;

implementation
uses
  SysUtils, Variants, StrUtils, uStreamUtils;

// TNodeTree -----------------------------------------------------------------

type
  TNodeTree = class(TTree)
  private
    FView: TCustomObjectTree;
    procedure OnFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
  protected
    procedure DoConnect; override;
    procedure DoDisconnect; override;
    property View: TCustomObjectTree read FView;
  public
    procedure AddChild(Parent: TTreeNode; Value: TTreeNode); override;
  public
    constructor Create(AView: TCustomObjectTree);
  end;

constructor TNodeTree.Create(AView: TCustomObjectTree);
begin
  inherited Create;
  FView := AView;
  FView.OnFreeNode := Self.OnFreeNode;
end;

{
function TNodeTree.GetRoot: TTreeNode;
begin
  Result := View.GetInternalData(View.RootNode)
end;
}

procedure TNodeTree.DoConnect;
const
  BaseHeight = 17; // TUNE:
var
  I: Integer;
  Col: TVirtualTreeColumn;
  NumLines: Integer;

  procedure UpdateNumLines(const Text: string);
  var
    Lines: TStrings;
  begin
    Lines := TStringList.Create;
    try
      Lines.Text := Text;
      if NumLines < Lines.Count then
        NumLines := Lines.Count;
    finally
      Lines.Free
    end
  end;

begin
  View.SetInternalData(View.RootNode, Root);

  // TODO: AutoSize by mlo roztahovat jenom koncov sloupce. coAutoSpring, hoAutoResize

  NumLines := 0;
  for I := 0 to Columns.Count - 1 do begin
    Col := View.Header.Columns.Add;
    if I < Columns.Count - 1 then
      Col.Options := Col.Options - [coAutoSpring]
    else
      Col.Options := Col.Options + [coAutoSpring];
    Col.Style := vsOwnerDraw;
    Col.Text := StringReplace(Columns[I].Caption, '\', #13#10, [rfReplaceAll]);
    UpdateNumLines(Col.Text);
    Col.Tag := I;
  end;

  if NumLines = 0 then
    NumLines := 1;

  { TODO: je teba zajistit shodn vzhled pro jednodkov i vcedkov zhlav }
  if True { TODO: NumLines > 1 } then begin
    View.Header.Options := View.Header.Options + [hoOwnerDraw];
    View.OnHeaderDrawQueryElements := View.PrepareMultilineHeader;
    View.OnAdvancedHeaderDraw := View.DrawMultilineHeader;
    View.Header.Height := NumLines * BaseHeight;
  end else begin
    View.Header.Options := View.Header.Options - [hoOwnerDraw];
    View.OnHeaderDrawQueryElements := nil;
    View.OnAdvancedHeaderDraw := nil;
    View.Header.Height := BaseHeight;
  end;

  if View.AutoSize then
    View.Header.Options := View.Header.Options + [hoAutoResize{, hoAutoSpring}]
  else
    View.Header.Options := View.Header.Options - [hoAutoResize{, hoAutoSpring}];

  View.EndUpdate;
end;

procedure TNodeTree.DoDisconnect;
begin
  if not (csDestroying in View.ComponentState) then begin
    View.BeginUpdate;
    View.Clear;
    View.Header.Columns.Clear;
    View.HasLevels := False;
    View.FDepth := -1;
    // TODO: ?
    View.EndUpdate;
    View.BeginUpdate
  end else begin
    // TODO: ?
    // View.OnFreeNode := nil
    View.Clear
  end
end;

procedure TNodeTree.AddChild(Parent: TTreeNode; Value: TTreeNode);
var
  Node: PVirtualNode;
begin
  if not Assigned(Parent) then
    Parent := Root;
  Node := View.AddChild(Parent.View);
  View.SetInternalData(Node, Value);
  if Parent <> Root then begin
    View.HasLevels := True;
  end
end;

procedure TNodeTree.OnFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
begin
  if Sender = View then
    View.GetInternalData(Node).Free;
end;

// TTreeLayout ----------------------------------------------------------------

constructor TColumnLayout.Create(ACollection: TCollection);
begin
  FWidth := 50;
  FVisible := True;
  inherited Create(ACollection)
end;

procedure TColumnLayout.Assign(Source: TPersistent);

  procedure LoadFrom(Source: TColumnLayout); overload;
  begin
    FColumnName := Source.FColumnName;
    FColumnPosition := Source.FColumnPosition;
    FHeaderAlignment := Source.FHeaderAlignment;
    FWidth := Source.FWidth;
    FVisible := Source.FVisible;
    FSorted := Source.FSorted
  end;

  procedure LoadFrom(Source: TVirtualTreeColumn); overload;
  var
    Tree: TCustomObjectTree;
    Col: TMappedColumn;
  begin
    Tree := TCustomObjectTree(Source.Owner.Header.Treeview);
    Col := Tree.Objects.Columns[Source.Index];
    FColumnName := Col.Name;
    FColumnPosition := Source.Position;
    FHeaderAlignment := Source.Alignment;
    FWidth := Source.Width;
    FVisible := coVisible in Source.Options;

    if Tree.Header.SortColumn = Source.Index then begin
      if Tree.Header.SortDirection = sdDescending then
        FSorted := csDown
      else
        FSorted := csUp;
    end else
      FSorted := csNone
  end;

begin
  if Source is TColumnLayout then
    LoadFrom(TColumnLayout(Source))
  else
  if Source is TVirtualTreeColumn then
    LoadFrom(TVirtualTreeColumn(Source))
  else
    inherited Assign(Source)
end;

procedure TColumnLayout.AssignTo(Dest: TPersistent);

  procedure SaveTo(Dest: TVirtualTreeColumn);
  var
    Tree: TCustomObjectTree;
  begin
    Tree := TCustomObjectTree(Dest.Owner.Header.Treeview);
    Dest.Position := FColumnPosition;
    Dest.Alignment := FHeaderAlignment;
    Dest.Width := FWidth;
    if FVisible then
      Dest.Options := Dest.Options + [coVisible]
    else
      Dest.Options := Dest.Options - [coVisible];
    case FSorted of
    csNone:
      begin
        if Tree.Header.SortColumn = Dest.Index then
          Tree.Header.SortColumn := NoColumn
      end;

    csUp:
      begin
        Tree.SetSortedColumn(Dest.Index, False);
      end;

    csDown:
      begin
        Tree.SetSortedColumn(Dest.Index, True);
      end;
    end
  end;

begin
  if Dest is TVirtualTreeColumn then
    SaveTo(TVirtualTreeColumn(Dest))
  else
    inherited AssignTo(Dest)
end;

function TColumnLayouts.GetItem(Index: Integer): TColumnLayout;
begin
  Result := TColumnLayout(inherited GetItem(Index))
end;

function TColumnLayouts.Add: TColumnLayout;
begin
  Result := TColumnLayout(inherited Add)
end;

constructor TTreeLayout.Create(AnOwner: TComponent);
begin
  FColumns := TColumnLayouts.Create(TColumnLayout);
  inherited Create(AnOwner);
end;

destructor TTreeLayout.Destroy;
begin
  inherited;
  FColumns.Free;
end;

procedure TTreeLayout.Clear;
begin
  FColumns.Clear
end;

procedure TTreeLayout.SetColumns(Value: TColumnLayouts);
begin
  if Value = nil then
    FColumns.Clear
  else
    FColumns.Assign(Value);
end;

procedure TTreeLayout.Assign(Source: TPersistent);

  procedure LoadFrom(Source: TTreeLayout); overload;
  var
    I: Integer;
  begin
    Clear;
    for I := 0 to Source.Columns.Count - 1 do
      Columns.Add.Assign(Source.Columns[I]);
  end;

  procedure LoadFrom(Source: TCustomObjectTree); overload;
  var
    I: Integer;
  begin
    Clear;
    for I := 0 to Source.Header.Columns.Count - 1 do
      Columns.Add.Assign(Source.Header.Columns[I]);
  end;

begin
  if Source is TTreeLayout then
    LoadFrom(TTreeLayout(Source))
  else
  if Source is TCustomObjectTree then
    LoadFrom(TCustomObjectTree(Source))
  else
    inherited Assign(Source)
end;

procedure TTreeLayout.AssignTo(Dest: TPersistent);

  procedure SaveTo(Dest: TCustomObjectTree);
  var
    I: Integer;
    C: Integer;
  begin
    for I := 0 to Columns.Count - 1 do begin
      C := Dest.Objects.Columns.IndexOf(Columns[I].ColumnName);
      if C >= 0 then
        Dest.Header.Columns[C].Assign(Columns[I]);
    end
  end;

begin
  if Dest is TCustomObjectTree then
    SaveTo(TCustomObjectTree(Dest))
  else
    inherited AssignTo(Dest)
end;

// TCustomObjectTree ----------------------------------------------------------

procedure TCustomObjectTree.AfterConstruction;
begin
  FInternalDataOffset := AllocateInternalDataArea(SizeOf(TTreeData));
  FObjects := TNodeTree.Create(Self);
  inherited;
  BeginUpdate;
  FDepth := -1
end;

type
  TOptions = class(TCustomVirtualTreeOptions)
  end;

constructor TCustomObjectTree.Create(AnOwner: TComponent);
begin
  inherited Create(AnOwner);
  with TOptions(TreeOptions) do begin
    SelectionOptions := SelectionOptions + [toExtendedFocus];
    PaintOptions := PaintOptions + [toShowVertGridLines, toShowHorzGridLines] - [toShowRoot];
    MiscOptions := MiscOptions + [toGridExtensions] { TUNE: - [toToggleOnDblClick]};
    AutoOptions := AutoOptions + [toAutoSort{ TODO: , toAutoSpanColumns}];
  end;
  Header.Options := Header.Options + [hoVisible, hoDblClickResize, hoShowSortGlyphs];
  Header.Background := Color;
  Header.Style := hsFlatButtons;     // TODO: na prepinac
  inherited OnChange := DoChange;
  inherited OnIncrementalSearch := DoIncrementalSearch;
  HintMode := hmToolTip;
  ShowHint := True;
  IncrementalSearch := isAll;
  IncrementalSearchStart := ssFocusedNode;
  AdjustColors;
  LineMode := lmBands       // TODO: na prepinac
end;

procedure TCustomObjectTree.DoIncrementalSearch(Sender: TBaseVirtualTree; Node: PVirtualNode; const SearchText: WideString; var Result: Integer);
begin
  if not AnsiStartsText(SearchText, Text[Node, FocusedColumn]) then
    Result := 1;
end;

procedure TCustomObjectTree.DoChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
begin
  if Assigned(FOnChange) then
    FOnChange(Self, GetInternalData(Node))
end;

procedure TCustomObjectTree.SetHasLevels(Value: Boolean);
begin
  if FHasLevels <> Value then begin
    FHasLevels := Value;
    with TOptions(TreeOptions) do
      if FHasLevels then
        PaintOptions := PaintOptions + [toShowRoot]
      else
        PaintOptions := PaintOptions - [toShowRoot]
  end
end;

function TCustomObjectTree.GetDepth: Integer;
var
  Node: PVirtualNode;
  D: Integer;
begin
  Result := FDepth;
  if Result < 0 then begin
    if not HasLevels then
      FDepth := 0
    else begin
      FDepth := 0;
      Node := GetFirst;
      while Assigned(Node) do begin
        D := GetNodeLevel(Node);
        if D > FDepth then
          FDepth := D;
        Node := GetNext(Node)
      end;
    end;
    Result := FDepth
  end
end;

destructor TCustomObjectTree.Destroy;
begin
  inherited;
  FObjects.Free
end;

function TCustomObjectTree.GetInternalData(Node: PVirtualNode): TTreeNode;
var
  P: PTreeData;
begin
  if Node = nil then
    Result := nil
  else begin
    P := PTreeData(PChar(Node) + FInternalDataOffset);
    Result := P^.Data;
    if Assigned(Result) and (Result.View <> Node) then begin
      Result.View := Node;
      Result.Key := P^.Key
    end
  end
end;

function TCustomObjectTree.GetInternalData(Node: PVirtualNode; ColumnIndex: Integer; var Column: TColumnDescriptor): TTreeNode;
begin
  Result := GetInternalData(Node);
  Column := nil;
  if Assigned(Result) and (ColumnIndex >= 0) then
    Column := Objects.Columns[ColumnIndex].Column(Result.Descriptor)
end;

procedure TCustomObjectTree.DoPaintNode(var PaintInfo: TVTPaintInfo);
var
  Data: TTreeNode;
  Col: TColumnDescriptor;
begin
  Data := GetInternalData(PaintInfo.Node, PaintInfo.Column, Col);

  if Assigned(Col) then
    PaintInfo.Alignment := Col.GetAlignment(Data);

  inherited DoPaintNode(PaintInfo)
end;

procedure TCustomObjectTree.DoGetText(Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var Text: WideString);
var
  Data: TTreeNode;
  Col: TColumnDescriptor;
begin
  Data := GetInternalData(Node, Column, Col);
  if Assigned(Col) then
    Text := Data.Strings[Col.Index]
  else
    Text := ''
end;

function TCustomObjectTree.DoCompare(Node1, Node2: PVirtualNode; Column: TColumnIndex): Integer;
var
  Data1, Data2: TTreeNode;
  Col1, Col2: TColumnDescriptor;
begin
  Data1 := GetInternalData(Node1, Column, Col1);
  Data2 := GetInternalData(Node2, Column, Col2);

  if Assigned(Col1) then begin
    if Assigned(Col2) then begin
      if Col1 = Col2 then
        Result := Col1.Compare(Data1, Data2)
      else
        Result := VarCompare(Data1.Values[Col1.Index], Data2.Values[Col2.Index]);
    end else
      Result := 1
  end else
  if Assigned(Col2) then begin
    Result := -1
  end else
    Result := 0
end;

procedure TCustomObjectTree.DoBeforeCellPaint(Canvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; CellRect: TRect);
var
  Color: TColor;
  N: TTreeNode;
  Col: TColumnDescriptor;
begin
  Color := clNone;
  if Assigned(FOnGetNodeColor) then begin
    FOnGetNodeColor(Self, GetInternalData(Node), Color);
  end;
  if Assigned(FOnGetCellColor) then begin
    N := GetInternalData(Node);
    Col := Objects.Columns[Column].Column(N.Descriptor);
    if Assigned(Col) then
      FOnGetCellColor(Self, N, Col, Color)
  end;
  if Color <> clNone then begin
    Canvas.Brush.Color := Color;
    Canvas.FillRect(CellRect);
  end;
  inherited;
end;

procedure TCustomObjectTree.PrepareMultilineHeader(Sender: TVTHeader; var PaintInfo: THeaderPaintInfo; var Elements: THeaderPaintElements);
begin
  if Assigned(PaintInfo.Column) then
    Elements := [hpeBackground, hpeText, hpeSortGlyph]
  else
    Elements := []
end;

procedure TCustomObjectTree.DrawMultilineHeader(Sender: TVTHeader; var PaintInfo: THeaderPaintInfo; const Elements: THeaderPaintElements);
const
  SortGlyphs: array[TSortDirection, Boolean] of Integer = ( // ascending/descending, normal/XP style
    (3, 5) {ascending}, (2, 4) {descending}
  );
var
  R: TRect;
  DrawFormat: Cardinal;
  DC: HDC;
  S: string;
  H: Integer;
  SortIndex: Integer;
  SortGlyphPos: TPoint;
  Brush: HBRUSH;
begin
  if hpeBackground in Elements then begin
    DC := PaintInfo.TargetCanvas.Handle;
    R := PaintInfo.PaintRectangle;
{   if PaintInfo.ShowSortGlyph then
      Brush := CreateSolidBrush(ColorToRGB(clHighlight))
    else }
    if not PaintInfo.ShowSortGlyph then begin
      Brush := CreateSolidBrush(ColorToRGB(clBtnFace));  // $E9E9E9)      // TODO: dej to na parametr
      Windows.FillRect(DC, R, Brush);
      DeleteObject(Brush);
      if PaintInfo.IsDownIndex then
        DrawEdge(DC, R, BDR_RAISEDINNER or BDR_RAISEDOUTER, BF_RECT or BF_SOFT or BF_FLAT)
      else
        DrawEdge(DC, R, BDR_RAISEDINNER or BDR_RAISEDOUTER, BF_RECT or BF_SOFT);
    end else begin
      PaintInfo.TargetCanvas.Brush.Bitmap := AllocPatternBitmap(clBtnFace, clBtnHighlight);
      PaintInfo.TargetCanvas.FillRect(R);
      if PaintInfo.IsDownIndex then
        DrawEdge(DC, R, BDR_SUNKENOUTER, BF_RECT)
      else
        DrawEdge(DC, R, BDR_RAISEDINNER, BF_RECT)
    end
  end;

  if hpeText in Elements then begin
    S := PaintInfo.Column.Text;
    if S <> '' then begin
      DC := PaintInfo.TargetCanvas.Handle;
      R := PaintInfo.PaintRectangle;
      OffsetRect(R, -R.Left, -R.Top);
      DrawFormat := DT_LEFT or DT_TOP or DT_END_ELLIPSIS or DT_CENTER;
      if Pos(#13, S) = 0 then
        DrawFormat := DrawFormat or DT_WORDBREAK;
      H := DrawText(DC, PChar(S), Length(S), R, DrawFormat or DT_CALCRECT);
      SetBkMode(DC, TRANSPARENT);
{      if PaintInfo.ShowSortGlyph then
        SetTextColor(DC, ColorToRGB(clHighlightText))
      else }
        SetTextColor(DC, ColorToRGB(Sender.Font.Color));
      R := PaintInfo.PaintRectangle;
      R.Top := R.Top + (R.Bottom - R.Top - H) div 2;
      DrawText(DC, PChar(S), Length(S), R, DrawFormat);
    end
  end;

  if (hpeSortGlyph in Elements) and PaintInfo.ShowSortGlyph then begin
    SortIndex := SortGlyphs[Sender.SortDirection, False { TODO: ttsUseThemes in States }];
    R := PaintInfo.PaintRectangle;
    SortGlyphPos.X := R.Right + 0 { TUNE: } - UtilityImages.Width;
    SortGlyphPos.Y := R.Top + ((R.Bottom - R.Top - UtilityImages.Height) div 2);
    UtilityImages.Draw(PaintInfo.TargetCanvas, SortGlyphPos.X, SortGlyphPos.Y, SortIndex);
  end
end;

procedure TCustomObjectTree.CMColorChange(var Message: TMessage);
begin
  Header.Background := Color;
  inherited;
  AdjustColors
end;

procedure TCustomObjectTree.CMSysColorChange(var Message: TMessage);
begin
  inherited;
  AdjustColors
end;

procedure TCustomObjectTree.Loaded;
begin
  inherited;
  AdjustColors
end;

procedure TCustomObjectTree.AdjustColors;
var
  C: TColor;
begin
  if csDesigning in ComponentState then exit;
  // TODO: to je nejaky divny maglajs
  C := ColorToRGB(Color);
  if C = ColorToRGB(Colors.GridLineColor) then begin
    if C = clSilver then
      Colors.GridLineColor := clGray
    else
      Colors.GridLineColor := clSilver
  end
end;

procedure TCustomObjectTree.DoHeaderClick(Column: TColumnIndex; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  OldSortColumn: TColumnIndex;
  OldSortDirection: TSortDirection;
begin
  OldSortColumn := Header.SortColumn;
  OldSortDirection := Header.SortDirection;
  inherited;
  if (Header.SortColumn = OldSortColumn) and (Header.SortDirection = OldSortDirection) then begin
    if OldSortColumn = Column then begin
      if Shift = [ssCtrl] then
        Header.SortColumn := NoColumn
      else begin
        if OldSortDirection = sdAscending then
          Header.SortDirection := sdDescending
        else
          Header.SortDirection := sdAscending
      end
    end else begin
      Header.SortColumn := NoColumn;
      Header.SortDirection := sdAscending;
      Header.SortColumn := Column
    end
  end
end;

procedure TCustomObjectTree.DoRefresh;
begin
  if Assigned(FOnRefresh) then
    FOnRefresh(Self)
end;

function TCustomObjectTree.DoKeyAction(var CharCode: Word; var Shift: TShiftState): Boolean;
begin
  Result := inherited DoKeyAction(CharCode, Shift);
  if Result then begin
    if (CharCode = Ord('F')) and (Shift = [ssCtrl]) then begin
      Result := False;
      FindDialogOpen
    end else
    if (CharCode = VK_F3) and (Shift = []) and FindDialogActive then begin
      Result := False;
      FindDialogFindNext
    end else
    if (CharCode = VK_F5) and (Shift = []) then begin
      Result := False;
      DoRefresh
    end
  end
end;

procedure TCustomObjectTree.HandleMouseDown(var Message: TWMMouse; const HitInfo: THitInfo);
var
  Hit: THitInfo;
begin
  Hit := HitInfo;
  // tohle je oprava proti vyberu radku i kdyz se klikne mimo
  if Hit.HitPositions = [hiNowhere] then
    Hit.HitNode := nil;
  inherited HandleMouseDown(Message, Hit)
end;

const
  DblClickOff = 0;
  DblClickProcessing = 1;
  DblClickRequest = 2;
  DblClickEvent = 3;

procedure TCustomObjectTree.HandleMouseDblClick(var Message: TWMMouse; const HitInfo: THitInfo);
var
  Hit: THitInfo;
begin
  Hit := HitInfo;
  // tohle je oprava proti vyberu radku i kdyz se klikne mimo
  if Hit.HitPositions = [hiNowhere] then
    Hit.HitNode := nil;
  if Hit.HitNode <> nil then
    if DblClickState = DblClickRequest then
      DblClickState := DblClickEvent;

  // tohle je oprava aby kolapsoval jenom hlavni sloupec
  if (toToggleOnDblClick in TOptions(TreeOptions).MiscOptions) and (Hit.HitNode <> nil) and (vsHasChildren in Hit.HitNode.States) then
    if Hit.HitColumn = Header.MainColumn then begin
      Hit.HitPositions := Hit.HitPositions + [hiOnItemLabel];
      // TODO: ma se vypnout udalost DblClick ?
      if DblClickState = DblClickEvent then
        DblClickState := DblClickRequest
    end else begin
      Hit.HitPositions := Hit.HitPositions - [hiOnItemButton, hiOnItemLabel, hiOnNormalIcon, hiOnStateIcon]
    end;

  inherited HandleMouseDblClick(Message, Hit)
end;

procedure TCustomObjectTree.DblClick;
begin
  if DblClickState in [DblClickOff, DblClickEvent] then
    inherited
  else
    DblClickState := DblClickRequest
end;

procedure TCustomObjectTree.WMLButtonDblClk(var Message: TWMLButtonDblClk);
begin
  DblClickState := DblClickProcessing;
  try
    inherited;
    DblClick
  finally
    DblClickState := DblClickOff
  end
end;

procedure TCustomObjectTree.SetSortedColumn(Index: Integer; Descending: Boolean);
begin
  Header.SortColumn := NoColumn;
  if Descending then
    Header.SortDirection := sdDescending
  else
    Header.SortDirection := sdAscending;
  Header.SortColumn := Index;
end;

function TCustomObjectTree.GetSortedColumn(var Column: TMappedColumn; var Descending: Boolean): Boolean;
var
  CI: Integer;
begin
  Descending := Header.SortDirection = sdDescending;
  CI := Header.SortColumn;
  if (CI < 0) or (CI >= Objects.Columns.Count) then
    Column := nil
  else
    Column := Objects.Columns[CI];
  Result := Assigned(Column)
end;

procedure TCustomObjectTree.SetInternalData(Node: PVirtualNode; Data: TTreeNode);
var
  P: PTreeData;
begin
  if Node <> nil then begin
    P := PTreeData(PChar(Node) + FInternalDataOffset);
    P^.Data := Data;
    if Assigned(Data) then begin
      // TODO: nemelo by se to nastavit jinudy ?
      Include(Node^.States, vsInitialUserData);
      P^.Key := Data.Key;
      Data.View := Node
    end
  end
end;

function TCustomObjectTree.GetFocusedNode: TTreeNode;
begin
  Result := GetInternalData(inherited FocusedNode);
end;

procedure TCustomObjectTree.SetFocusedNode(Value: TTreeNode);
begin
  if Assigned(Value) then
    inherited FocusedNode := PVirtualNode(Value.View)
  else
    inherited FocusedNode := nil
end;

function TCustomObjectTree.GetSelectedNode: TTreeNode;
begin
  Result := GetInternalData(GetFirstSelected)
end;

procedure TCustomObjectTree.SetSelectedNode(Value: TTreeNode);
var
  Node: PVirtualNode;
begin
  if Assigned(Value) then
    Node := PVirtualNode(Value.View)
  else
    Node := nil;

  if Assigned(Node) then begin
    BeginUpdate;
    try
      ClearSelection;
      inherited Selected[Node] := True;
    finally
      EndUpdate
    end
  end else
    ClearSelection
end;

function TCustomObjectTree.GetSelectedColumn: TMappedColumn;
var
  CI: Integer;
begin
  Result := nil;
  CI := FocusedColumn;
  if (CI < 0) or (CI >= Objects.Columns.Count) then exit;
  Result := Objects.Columns[CI]
end;

procedure TCustomObjectTree.SetSelectedColumn(Value: TMappedColumn);
begin
  if Assigned(Value) then
    FocusedColumn := Value.Index
end;

function TCustomObjectTree.GetCurrentPath: string;
begin
  Result := GetPath(FocusedNode)
end;

procedure TCustomObjectTree.SetCurrentPath(const Value: string);
var
  Node: TTreeNode;
begin
  Node := GetPath(Value);
  Selected := Node;
  FocusedNode := Node
end;

const
  PathDelimiter = '\';    // TUNE:

function TCustomObjectTree.GetPath(Node: TTreeNode): string;
begin
  if Assigned(Node) then begin
    Result := inherited Path(PVirtualNode(Node.View), Header.MainColumn, ttStatic, PathDelimiter);
    SetLength(Result, Length(Result) - 1)
  end else
    Result := PathDelimiter
end;

function TCustomObjectTree.GetParent(Node: TTreeNode; Depth: Integer): TTreeNode;
var
  V: PVirtualNode;
begin
  while Depth >= 0 do begin
    Result := nil;
    if not Assigned(Node) then exit;
    V := PVirtualNode(Node.View);
    if not Assigned(V) then exit;
    if not Assigned(V^.Parent) then exit;
    Result := GetInternalData(V^.Parent);
    
    Node := Result;
    Dec(Depth)
  end
end;

function TCustomObjectTree.GetPath(const Path: string): TTreeNode;

  function FindNode(Root: TTreeNode; const Path: string): TTreeNode;
  var
    View: PVirtualNode;
    Node: PVirtualNode;
  begin
    View := PVirtualNode(Root.View);
    Node := View^.FirstChild;
    while Assigned(Node) do begin
      if SameText(Text[Node, Header.MainColumn], Path) then begin
        Result := GetInternalData(Node);
        exit
      end;
      Node := Node^.NextSibling
    end;
    Result := nil
  end;

var
  Trail: TStrings;
  I: Integer;
  Node: TTreeNode;
begin
  Trail := TStringList.Create;
  try
    Trail.Text := StringReplace(Path, PathDelimiter, #13#10, [rfReplaceAll]);
    Result := nil;
    Node := Objects.Root;
    for I := 0 to Trail.Count - 1 do begin
      Node := FindNode(Node, Trail[I]);
      if not Assigned(Node) then exit;
    end;
    if Node <> Objects.Root then
      Result := Node
  finally
    Trail.Free
  end
end;

//-------------------------------------------------------------------------------

type
  TDialogManager = class(TComponent)
  private
    Client: TCustomObjectTree;
    FindDialog: TFindDialog;
    procedure FindDialogFind(Sender: TObject);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    procedure FindDialogOpen(Sender: TCustomObjectTree);
    procedure FindDialogFindNext;
    function FindDialogActive: Boolean;
  end;

procedure TDialogManager.FindDialogOpen(Sender: TCustomObjectTree);
begin
  Client := Sender;
  if Assigned(FindDialog) then
    FindDialog.Execute
  else begin
    FindDialog := TFindDialog.Create(Self);
    FindDialog.FreeNotification(Self);
    FindDialog.OnFind := FindDialogFind;
    FindDialog.Execute
  end
end;

function TDialogManager.FindDialogActive: Boolean;
begin
  Result := Assigned(FindDialog) and (FindDialog.FindText <> '')
end;

procedure TDialogManager.FindDialogFindNext;
begin
  FindDialogFind(FindDialog)
end;

procedure TDialogManager.FindDialogFind(Sender: TObject);
var
  Node: PVirtualNode;
  Column: Integer;
begin
  if Assigned(Client) and Client.CanFocus and Assigned(FindDialog) then begin
    // TODO: Client.SetFocus;
    if Client.Find(
      FindDialog.FindText,
      frMatchCase in FindDialog.Options,
      frDown in FindDialog.Options,
      frWholeWord in FindDialog.Options,
      Node, Column) then begin
        Client.Selected := Client.GetInternalData(Node);
        Client.FocusedNode := Client.GetInternalData(Node);
        Client.FocusedColumn := Column;
        Client.DoChange(Client, Node);
    end;
  end;
end;

var
  DialogManager: TDialogManager = nil;

procedure TDialogManager.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (AComponent = FindDialog) and (Operation = opRemove) then
    FindDialog := nil;
  inherited
end;

procedure TCustomObjectTree.FindDialogOpen;
begin
  if not Assigned(DialogManager) then
    DialogManager := TDialogManager.Create(nil);

  DialogManager.FindDialogOpen(Self);
end;

function TCustomObjectTree.Find(const SearchText: string; MatchCase: Boolean; Down: Boolean; WholeWord: Boolean; var Node: PVirtualNode; var Column: Integer): Boolean;
var
  StartNode: PVirtualNode;
  StartColumn: Integer;
  S: string;
begin
  StartNode := inherited GetFirstSelected;
  if not Assigned(StartNode) then
    StartNode := GetFirst;
  StartColumn := FocusedColumn;
  if StartColumn < 0 then
    if Header.Columns.Count > 0 then
      StartColumn := 0;
  Result := False;
  if (not Assigned(StartNode)) or (StartColumn < 0) then exit;

  Node := StartNode;
  Column := StartColumn + 1;
  while True do begin
    if Column >= Header.Columns.Count then begin
      Column := 0;
      Node := GetNext(Node)
    end;
    if Node = nil then
      Node := GetFirstVisible;
    if (Node = StartNode) and (Column = StartColumn) then exit;
    S := Text[Node, Column];
    if MatchCase then begin
      if WholeWord then
        // TODO:
        Result := SearchText = S
      else
        Result := Pos(SearchText, S) <> 0
    end else begin
      if WholeWord then
        // TODO:
        Result := AnsiSameText(SearchText, S)
      else
        Result := AnsiContainsText(S, SearchText)
    end;
    if Result then exit;
    Inc(Column)
  end
end;

procedure TCustomObjectTree.FindDialogFindNext;
begin
  DialogManager.FindDialogFindNext;
end;

function TCustomObjectTree.FindDialogActive: Boolean;
begin
  Result := Assigned(DialogManager) and DialogManager.FindDialogActive
end;

//----------------------------------------------------------------------------

var
  Layouts: TStrings = nil;

procedure ReleaseLayouts;
var
  I: Integer;
begin
  if Assigned(Layouts) then begin
    for I := 0 to Layouts.Count - 1 do
      Layouts.Objects[I].Free;
    FreeAndNil(Layouts)
  end
end;

function LoadLayout(const ID: string; Tree: TCustomObjectTree): Integer;
var
  I: Integer;
begin
  Result := 0;
  if Assigned(Layouts) then begin
    I := Layouts.IndexOf(ID);
    if I >= 0 then begin
      Tree.Assign(TTreeLayout(Layouts.Objects[I]));
      Result := TTreeLayout(Layouts.Objects[I]).Tag
    end
  end
end;

function GetLayout(const ID: string): TTreeLayout;
var
  I: Integer;
begin
  if not Assigned(Layouts) then begin
    Layouts := TStringList.Create;
    TStringList(Layouts).Sorted := True
  end;
  I := Layouts.IndexOf(ID);
  if I < 0 then
    I := Layouts.AddObject(ID, TTreeLayout.Create(nil));
  Result := TTreeLayout(Layouts.Objects[I])
end;

procedure SaveLayout(const ID: string; Tree: TCustomObjectTree; Tag: Integer);
var
  Layout: TTreeLayout;
begin
  Layout := GetLayout(ID);
  Layout.Assign(Tree);
  Layout.Tag := Tag
end;

procedure LoadFromIni(Ini: TCustomIniFile; const Section: string; Layout: TTreeLayout); overload;
var
  Stream: TStream;
begin
  Stream := TMemoryStream.Create;
  try
    uStreamUtils.ObjectIniToBinary(Ini, Section, Stream, Layout.ClassName);
    Stream.Position := 0;
    Stream.ReadComponent(Layout)
  finally
    Stream.Free
  end
end;

procedure LoadLayoutsFromIni(Ini: TCustomIniFile; const Section: string);
var
  List: TStrings;
  I, J, K: Integer;
  ID: string;
  Loaded: TStringList;
begin
  List := TStringList.Create;
  Loaded := TStringList.Create;
  Loaded.Sorted := True;
  try
    Ini.ReadSections(List);
    for I := 0 to List.Count - 1 do
      if AnsiStartsText(Section + '.', List[I]) then begin
        ID := Copy(List[I], Length(Section) + 2, MaxInt);
        J := Pos('.', ID);
        if J <> 0 then
          SetLength(ID, J - 1);
        if Loaded.IndexOf(ID) < 0 then begin
          Loaded.Add(ID);
          LoadFromIni(Ini, Section + '.' + ID, GetLayout(ID))
        end
      end
  finally
    Loaded.Free;
    List.Free
  end
end;

procedure SaveToIni(Ini: TCustomIniFile; const Section: string; Layout: TTreeLayout); overload;
begin
  uStreamUtils.SaveToIni(Ini, Section, Layout);
end;

procedure SaveLayoutsToIni(Ini: TCustomIniFile; const Section: string);
var
  List: TStrings;
  I: Integer;
begin
  List := TStringList.Create;
  try
    Ini.ReadSections(List);
    for I := 0 to List.Count - 1 do begin
      if AnsiStartsText(Section + '.', List[I]) then
        Ini.EraseSection(List[I])
    end
  finally
    List.Free
  end;
  if Assigned(Layouts) then
    for I := 0 to Layouts.Count - 1 do
      SaveToIni(Ini, Section + '.' + Layouts[I], TTreeLayout(Layouts.Objects[I]))
end;

//----------------------------------------------------------------------------

procedure Register;
begin
  RegisterComponents('Additional', [TObjectTree]);
end;

initialization
finalization
  DialogManager.Free;
  ReleaseLayouts;
end.
