{ VERSION: 1.2 }
{ Definuje strom objekt s pamt }
{ 1.2 / 1.5.2005
  1.1 / 26.4.2005
}
unit uStringTree;

interface
uses
  Classes, uObjectTree;

type
  TStringNodeManager = class(TNodeManager)
  protected
    function CreateDescriptors: TNodeDescriptors; override;
  public
    function CreateRootNode(ADescriptor: TNodeDescriptor): TTreeNode; override;
  end;

  TStringNodeDescriptor = class(TNodeDescriptor)
  end;

  TStringNode = class(TTreeNode)
  private
    FValues: array of string;
    FManager: TStringNodeManager;
    FDescriptor: TStringNodeDescriptor;
  protected
    constructor Create(AManager: TStringNodeManager; ADescriptor: TStringNodeDescriptor);
    function GetManager: TNodeManager; override;
    function GetDescriptor: TNodeDescriptor; override;
  protected
    function GetValueAsCode(Index: Integer): string; override;
    procedure SetValueAsCode(Index: Integer; const Value: string); override;
  end;

implementation

// TStringNode ---------------------------------------------------------------

constructor TStringNode.Create(AManager: TStringNodeManager; ADescriptor: TStringNodeDescriptor);
begin
  inherited Create;
  FManager := AManager;
  FDescriptor := ADescriptor;
  if Assigned(FDescriptor) then
    SetLength(FValues, FDescriptor.Columns.Count)
end;

function TStringNode.GetManager: TNodeManager;
begin
  Result := FManager
end;

function TStringNode.GetDescriptor: TNodeDescriptor;
begin
  Result := FDescriptor
end;

function TStringNode.GetValueAsCode(Index: Integer): string;
begin
  Result := FValues[Index]
end;

procedure TStringNode.SetValueAsCode(Index: Integer; const Value: string);
begin
  FValues[Index] := Value
end;

// TStringNodeManager ---------------------------------------------------------

function TStringNodeManager.CreateDescriptors: TNodeDescriptors;
begin
  Result := TNodeDescriptors.Create(TStringNodeDescriptor);
end;

function TStringNodeManager.CreateRootNode(ADescriptor: TNodeDescriptor): TTreeNode;
begin
  Result := TStringNode.Create(Self, ADescriptor as TStringNodeDescriptor);
end;

end.
