/* 
   AppID = "TODO"
   AppVersion = 4
*/

create table TaskGroup (
  GroupID {db.type.generator} not null primary key,
  Description {db.type.string(40)},
  NumSeed {db.type.integer},
  Modified {db.type.datetime}
);

type.userID = '{db.type.integer}';

create table Task (
  TaskID {db.type.generator} not null primary key,
  GroupID {db.type.generator},
  Num {db.type.integer},
  Module {db.type.string(40)},
  Created {db.type.datetime},
  Resolved {db.type.datetime},
  Closed {db.type.datetime},
  Notes {db.type.memo},
  Priority {db.type.integer},
  Category {db.type.integer},
  Status {db.type.integer},
  Activity {db.type.integer},
  Milestone {db.type.date},
  ReporterID {type.userID},
  SolverID {type.userID}
);

create table TaskNote (
  NoteID {db.type.generator} not null primary key,
  TaskID {db.type.generator},
  GroupID {db.type.generator},
  Created {db.type.datetime},
  Notes {db.type.memo},
  ReporterID {type.userID}
);

create table {app.table.name(PriorityEnum)} (
  Num {db.type.integer} not null primary key,
  NumCode {db.type.string(40)},
  Description {db.type.string(40)}
);

create index Task_1
  on Task(Num);

create index Task_2
  on Task(GroupID);
  
create index TaskNote_1
  on TaskNote(GroupID); 

@insert = 'insert into {app.table.name(PriorityEnum)}(Num, NumCode, Description) values';

{@insert} (1, 'highFix'       , 'mus se vyeit !!');
{@insert} (2, 'mediumFix'     , 'mus se vyeit !' );
{@insert} (3, 'lowFix'        , 'mus se vyeit'   );
{@insert} (4, 'highWhenIdle'  , 'a bude as !!'    );
{@insert} (5, 'mediumWhenIdle', 'a bude as !'     );
{@insert} (6, 'lowWhenIdle'   , 'a bude as'       );
{@insert} (7, 'dontFix'       , 'neeit'           );

create table {app.table.name(CategoryEnum)} (
  Num {db.type.integer} not null primary key,
  NumCode {db.type.string(40)},
  Description {db.type.string(40)}
);

@insert = 'insert into {app.table.name(CategoryEnum)}(Num, NumCode, Description) values';

{@insert} (1, 'bug'     , 'chyba'  );
{@insert} (2, 'task'    , 'kol'   );
{@insert} (3, 'feature' , 'nmt'  );
{@insert} (4, 'question', 'otzka' );
{@insert} (5, 'event'   , 'udlost');

create table {app.table.name(StatusEnum)} (
  Num {db.type.integer} not null primary key,
  NumCode {db.type.string(40)},
  Description {db.type.string(40)}
);

@insert = 'insert into {app.table.name(StatusEnum)}(Num, NumCode, Description) values';

{@insert} (1 , 'active'                   , 'aktivn'                );
{@insert} (2 , 'bugFixed'                 , 'opraveno'               );
{@insert} (3 , 'bugNoReproduce'           , 'neopakovateln'         );
{@insert} (4 , 'bugDuplicate'             , 'duplicitn'             );
{@insert} (5 , 'bugPostponed'             , 'odloeno'               );
{@insert} (6 , 'bugWontFix'               , 'nebude se opravovat'    );
{@insert} (7 , 'bugNotBug'                , 'vlastnost nen chyba'   );
{@insert} (8 , 'taskFixed'                , 'splnno'                );
{@insert} (9 , 'taskDuplicate'            , 'duplicitn'             );
{@insert} (10, 'taskWontFix'              , 'nebude se dlat'        );
{@insert} (11, 'taskAlreadyImplemented'   , 'u je to hotov'        );
{@insert} (12, 'featureImplemented'       , 'implementovno'         );
{@insert} (13, 'featureWontImplement'     , 'nebude se implementovat');
{@insert} (14, 'featureAlreadyImplemented', 'u implementovno'      );
{@insert} (15, 'questionResponded'        , 'zodpovzena'            );
{@insert} (16, 'questionWontRespond'      , 'nebude se reagovat'     );
{@insert} (17, 'questionSPAM'             , 'um'                    );
{@insert} (18, 'questionWaitingForInfo'   , 'je teba vce informac');
{@insert} (19, 'featureDuplicate'         , 'duplicitn poadavek'   );

create table {app.table.name(ActivityEnum)} (
  Num {db.type.integer} not null primary key,
  NumCode {db.type.string(40)},
  Description {db.type.string(40)}
);

@insert = 'insert into {app.table.name(ActivityEnum)}(Num, NumCode, Description) values';

{@insert} (1, 'notStarted'          , 'ek'               );
{@insert} (2, 'scheduledDevelopment', 'plnovan vroba'   );
{@insert} (3, 'developing'          , 've vrob'          );
{@insert} (4, 'scheduledTesting'    , 'plnovan testovn');
{@insert} (5, 'testing'             , 'v testovn'        );
{@insert} (6, 'complete'            , 'hotovo'             );
{@insert} (7, 'closed'              , 'uzaveno'           );
{@insert} (8, 'deleted'             , 'smazno'            );